#lang racket
;;;
;;; Racket starter code for CS241 A3
;;;
;;; This file contains an area where you can put your main code (or all
;;; of your code) for A3.

(require "scanning.rkt")

(define (encode instr)
  (write-byte (bitwise-and (arithmetic-shift instr -24) #xFF)) 
  (write-byte (bitwise-and (arithmetic-shift instr -16) #xFF))
  (write-byte (bitwise-and (arithmetic-shift instr -8) #xFF))
  (write-byte (bitwise-and instr #xFF))
)

(define (worddirec lot)
    (define input 0)
    (define term (second lot))
    (cond[(eq? (token-kind (second lot)) 'ID) (set! input (findadd (token-lexeme term)))]
         [(eq? (token-kind (second lot)) 'INT) (set! input (token-int-value term))]
         [(eq? (token-kind (second lot)) 'HEXINT) (set! input (token-int-value term))])

    (define instr (bitwise-and input #xFFFFFFFF))
    (encode instr)
)

(define (adddirec lot)
  (define d (token-int-value (second lot)))
  (define s (token-int-value (fourth lot)))
  (define t (token-int-value (sixth lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (arithmetic-shift d 11)
                             32))
  (encode instr)
)

(define (subdirec lot)
  (define d (token-int-value (second lot)))
  (define s (token-int-value (fourth lot)))
  (define t (token-int-value (sixth lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (arithmetic-shift d 11)
                             34))
  (encode instr)
)

(define (sltdirec lot)
  (define d (token-int-value (second lot)))
  (define s (token-int-value (fourth lot)))
  (define t (token-int-value (sixth lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (arithmetic-shift d 11)
                             42))
  (encode instr)
)

(define (sltudirec lot)
  (define d (token-int-value (second lot)))
  (define s (token-int-value (fourth lot)))
  (define t (token-int-value (sixth lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (arithmetic-shift d 11)
                             43))
  (encode instr)
)

(define (multdirec lot)
  (define s (token-int-value (second lot)))
  (define t (token-int-value (fourth lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (arithmetic-shift 0 11)
                             24))
  (encode instr)
)

(define (multudirec lot)
  (define s (token-int-value (second lot)))
  (define t (token-int-value (fourth lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (arithmetic-shift 0 11)
                             25))
  (encode instr)
)

(define (divdirec lot)
  (define s (token-int-value (second lot)))
  (define t (token-int-value (fourth lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (arithmetic-shift 0 11)
                             26))
  (encode instr)
)

(define (divudirec lot)
  (define s (token-int-value (second lot)))
  (define t (token-int-value (fourth lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (arithmetic-shift 0 11)
                             27))
  (encode instr)
)

(define (mfhidirec lot)
  (define d (token-int-value (second lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift 0 21)
                             (arithmetic-shift 0 16)
                             (arithmetic-shift d 11)
                             16))
  (encode instr)
)

(define (mflodirec lot)
  (define d (token-int-value (second lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift 0 21)
                             (arithmetic-shift 0 16)
                             (arithmetic-shift d 11)
                             18))
  (encode instr)
)

(define (lisdirec lot)
  (define d (token-int-value (second lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift 0 21)
                             (arithmetic-shift 0 16)
                             (arithmetic-shift d 11)
                             20))
  (encode instr)
)

(define (beqdirec lot pc)
  (define s (token-int-value (second lot)))
  (define t (token-int-value (fourth lot)))
  (define i (token-lexeme (sixth lot)))
  (define add (findadd i))
  (cond[(eq? (token-kind (sixth lot)) 'ID) (set! i (- (/ (- add pc) 4) 1))]
       [else (set! i (token-int-value (sixth lot)))])
  (define instr (bitwise-ior (arithmetic-shift 4 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (bitwise-and i #xFFFF)))
  (encode instr)
)

(define (bnedirec lot pc)
  (define s (token-int-value (second lot)))
  (define t (token-int-value (fourth lot)))
  (define i (token-lexeme (sixth lot)))
  (define add (findadd i))
  (cond[(eq? (token-kind (sixth lot)) 'ID) (set! i (- (/ (- add pc) 4) 1))]
       [else (set! i (token-int-value (sixth lot)))])
  (define instr (bitwise-ior (arithmetic-shift 5 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (bitwise-and i #xFFFF)))
  (encode instr)
)

(define (lwdirec lot)
  (define t (token-int-value (second lot)))
  (define s (token-int-value (sixth lot)))
  (define i (token-int-value (fourth lot)))
  (define instr (bitwise-ior (arithmetic-shift 35 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (bitwise-and i #xFFFF)))
  (encode instr)
)

(define (swdirec lot)
  (define t (token-int-value (second lot)))
  (define s (token-int-value (sixth lot)))
  (define i (token-int-value (fourth lot)))
  (define instr (bitwise-ior (arithmetic-shift 43 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift t 16)
                             (bitwise-and i #xFFFF)))
  (encode instr)
)

(define (jrdirec lot)
  (define s (token-int-value (second lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift 0 16)
                             (arithmetic-shift 0 11)
                             8))
  (encode instr)
)

(define (jalrdirec lot)
  (define s (token-int-value (second lot)))
  (define instr (bitwise-ior (arithmetic-shift 0 26)
                             (arithmetic-shift s 21)
                             (arithmetic-shift 0 16)
                             (arithmetic-shift 0 11)
                             9))
  (encode instr)
)

; getting label address
(define (labelfetch tok pc)
  (cond[(string=? (token-kind tok) "LABEL") 
          (set! symboltable (cons '((token-lexeme tok) pc) symboltable))])
)

; determining if anything but labels exists
(define (increasepc? lsttok)
  (define linelen (length lsttok))
  (define result #f)
  (for ([i linelen])
    (cond[(not (eq? (token-kind (list-ref lsttok i)) 'LABEL)) (set! result #t)])
  )
  result
)

; increment
(define (increment i)
  (define result (+ i 4))
  result
)

; remove labels (ones that come before instructions)
(define (clean lot)
  (define lenlot (length lot))
  (define cut 0)
  (for ([i lenlot])
    (define token (list-ref lot i))
    (define type (token-kind token))
    (cond[(eq? type 'LABEL) (set! cut (+ i 1))])
  )
  (list-tail lot cut)
)

(define (validadd? lot)
  (define len (length lot))
  (define result #t)
  (cond[(not (eq? len 6)) (set! result #f)]
       [(not (and (eq? (token-kind (second lot)) 'REG)
                  (eq? (token-kind (third lot)) 'COMMA)
                  (eq? (token-kind (fourth lot)) 'REG)
                  (eq? (token-kind (fifth lot)) 'COMMA)
                  (eq? (token-kind (sixth lot)) 'REG)
        )) (set! result #f)]
  )
  result
)

(define (hex-inrange? tok)
  (define ival (token-int-value tok))
  (define result #t)
  (cond[(not (and (>= ival 0) (<= ival 65535))) (set! result #f)])
  result
)

(define (int-inrange? tok)
  (define ival (token-int-value tok))
  (define result #t)
  (cond[(not (and (>= ival -32768) (<= ival 32767))) (set! result #f)])
  result
)

(define (wordint-inrange? tok)
  (define ival (token-int-value tok))
  (define result #t)
  (cond[(not (and (>= ival -2147483648) (<= ival 4294967295))) (set! result #f)])
  result
)

(define (wordhex-inrange? tok)
  (define ival (token-int-value tok))
  (define result #t)
  (cond[(not (and (>= ival 0) (<= ival 4294967295))) (set! result #f)])
  result
)

(define (validword? lot)
  (define len (length lot))
  (define result #t)
  (cond[(not (eq? len 2)) (set! result #f)]
       [(not (or (eq? (token-kind (second lot)) 'INT)
                 (eq? (token-kind (second lot)) 'HEXINT)
                 (eq? (token-kind (second lot)) 'ID))) (set! result #f)]
       [(and (eq? (token-kind (second lot)) 'ID) 
             (not (hash-ref symboltable (token-lexeme (second lot)) #f))) (set! result #f)]
       [(and (eq? (token-kind (second lot)) 'INT) 
             (not (wordint-inrange? (second lot)))) (set! result #f)]
       [(and (eq? (token-kind (second lot)) 'HEXINT) 
             (not (wordhex-inrange? (second lot)))) (set! result #f)])
  result
)

(define (validbeq? lot)
  (define len (length lot))
  (define result #t)
  (cond[(not (eq? len 6)) (set! result #f)]
       [(not (and (eq? (token-kind (second lot)) 'REG)
                  (eq? (token-kind (third lot)) 'COMMA)
                  (eq? (token-kind (fourth lot)) 'REG)
                  (eq? (token-kind (fifth lot)) 'COMMA)
                  (or (eq? (token-kind (sixth lot)) 'HEXINT)
                      (eq? (token-kind (sixth lot)) 'INT)
                      (eq? (token-kind (sixth lot)) 'ID)))) (set! result #f)]
       [(and (eq? (token-kind (sixth lot)) 'ID) 
             (not (hash-ref symboltable (token-lexeme (sixth lot)) #f))) (set! result #f)]
       [(and (eq? (token-kind (sixth lot)) 'INT) 
             (not (int-inrange? (sixth lot)))) (set! result #f)]
       [(and (eq? (token-kind (sixth lot)) 'HEXINT) 
             (not (hex-inrange? (sixth lot)))) (set! result #f)])
  result
)

(define (validmult? lot)
  (define len (length lot))
  (define result #t)
  (cond[(not (eq? len 4)) (set! result #f)]
       [(not (and (eq? (token-kind (second lot)) 'REG)
                  (eq? (token-kind (third lot)) 'COMMA)
                  (eq? (token-kind (fourth lot)) 'REG))) (set! result #f)])
  result
)

(define (validmfhi? lot)
  (define len (length lot))
  (define result #t)
  (cond[(not (eq? len 2)) (set! result #f)]
       [(not (and (eq? (token-kind (second lot)) 'REG))) (set! result #f)])
  result
)

(define (validlw? lot)
  (define len (length lot))
  (define result #t)
  (cond[(not (eq? len 7)) (set! result #f)]
       [(not (and (eq? (token-kind (second lot)) 'REG)
                  (eq? (token-kind (third lot)) 'COMMA)
                  (or (eq? (token-kind (fourth lot)) 'INT)
                      (eq? (token-kind (fourth lot)) 'HEXINT))
                  (eq? (token-kind (fifth lot)) 'LPAREN)
                  (eq? (token-kind (sixth lot)) 'REG)
                  (eq? (token-kind (seventh lot)) 'RPAREN))) (set! result #f)]
       [(and (eq? (token-kind (fourth lot)) 'INT)
             (not (int-inrange? (fourth lot)))) (set! result #f)]
       [(and (eq? (token-kind (fourth lot)) 'HEXINT)
             (not (hex-inrange? (fourth lot)))) (set! result #f)])
  result
)

(define (validjr? lot)
  (define len (length lot))
  (define result #t)
  (cond[(not (eq? len 2)) (set! result #f)]
       [(not (eq? (token-kind (second lot)) 'REG)) (set! result #f)])
  result
)

(define (checkregisters lot)
  (define len (length lot))
  (define result #t)
  (for ([i len])
    (define token (list-ref lot i))
    (define kind (token-kind token))
    (define lexeme (token-lexeme token))
    (define n (string-length lexeme))
    (cond[(and (eq? kind 'REG) (not (and (>= (string->number (substring lexeme 1 n)) 0)
                               (<= (string->number (substring lexeme 1 n)) 31))))
                               (set! result #f)])
  )
  result
)

; (define n (string-length info))
; (substring info 0 (- n 1))

(define (valid? lot)
  (define firsttok (first lot))
  (define kind (token-kind firsttok))
  (define lexeme (token-lexeme firsttok))
  (define result #t)
  (cond[(and (string=? lexeme "add") (not (validadd? lot))) (set! result #f)]
       [(and (string=? lexeme ".word") (not (validword? lot))) (set! result #f)]
       [(and (string=? lexeme "beq") (not (validbeq? lot))) (set! result #f)]
       [(and (string=? lexeme "bne") (not (validbeq? lot))) (set! result #f)]
       [(and (string=? lexeme "sub") (not (validadd? lot))) (set! result #f)]
       [(and (string=? lexeme "slt") (not (validadd? lot))) (set! result #f)]
       [(and (string=? lexeme "sltu") (not (validadd? lot))) (set! result #f)]
       [(and (string=? lexeme "mult") (not (validmult? lot))) (set! result #f)]
       [(and (string=? lexeme "multu") (not (validmult? lot))) (set! result #f)]
       [(and (string=? lexeme "div") (not (validmult? lot))) (set! result #f)]
       [(and (string=? lexeme "divu") (not (validmult? lot))) (set! result #f)]
       [(and (string=? lexeme "mfhi") (not (validmfhi? lot))) (set! result #f)]
       [(and (string=? lexeme "mflo") (not (validmfhi? lot))) (set! result #f)]
       [(and (string=? lexeme "lis") (not (validmfhi? lot))) (set! result #f)]
       [(and (string=? lexeme "lw") (not (validlw? lot))) (set! result #f)]
       [(and (string=? lexeme "sw") (not (validlw? lot))) (set! result #f)]
       [(and (string=? lexeme "jr") (not (validjr? lot))) (set! result #f)]
       [(and (string=? lexeme "jalr") (not (validjr? lot))) (set! result #f)]
       [(not (or (string=? lexeme "add") (string=? lexeme ".word")
                 (string=? lexeme "beq") (string=? lexeme "bne")
                 (string=? lexeme "sub") (string=? lexeme "slt")
                 (string=? lexeme "sltu") (string=? lexeme "mult")
                 (string=? lexeme "multu") (string=? lexeme "div")
                 (string=? lexeme "divu") (string=? lexeme "mfhi")
                 (string=? lexeme "mflo") (string=? lexeme "lis")
                 (string=? lexeme "lw") (string=? lexeme "sw")
                 (string=? lexeme "jr") (string=? lexeme "jalr"))) (set! result #f)])
  result
)


; takes cleaned line and calls directive function
(define (dealer lot pc)
  (define firsttok (first lot))
  (define firsttype (token-lexeme firsttok))
  (cond[(string=? firsttype ".word") (worddirec lot)]
       [(string=? firsttype "add") (adddirec lot)]
       [(string=? firsttype "beq") (beqdirec lot pc)]
       [(string=? firsttype "bne") (bnedirec lot pc)]
       [(string=? firsttype "sub") (subdirec lot)]
       [(string=? firsttype "slt") (sltdirec lot)]
       [(string=? firsttype "sltu") (sltudirec lot)]
       [(string=? firsttype "mult") (multdirec lot)]
       [(string=? firsttype "multu") (multudirec lot)]
       [(string=? firsttype "div") (divdirec lot)]
       [(string=? firsttype "divu") (divudirec lot)]
       [(string=? firsttype "mfhi") (mfhidirec lot)]
       [(string=? firsttype "mflo") (mflodirec lot)]
       [(string=? firsttype "lis") (lisdirec lot)]
       [(string=? firsttype "lw") (lwdirec lot)]
       [(string=? firsttype "sw") (swdirec lot)]
       [(string=? firsttype "jr") (jrdirec lot)]
       [(string=? firsttype "jalr") (jalrdirec lot)])
)

(define (findadd label) 
    (define result (hash-ref symboltable label -1))
    result
)

(define program '())
(define symboltable (make-hash))

(for [(line (in-lines))]
  (define tokens (scan line))
  (cond [(eq? tokens '())]
        [else (set! program (cons tokens program))])
)

(set! program (reverse program))
(define PC 0)
(define proglen (length program))

; Building symbol table
(for ([i proglen])
  (define line (list-ref program i))
  (define linelen (length line))
  (for ([j linelen])
    (define token (list-ref line j))
    (define type (token-kind token))
    (define info (token-lexeme token))
    (define n (string-length info))
    (set! info (substring info 0 (- n 1)))
    (cond[(and (eq? type 'LABEL) (not (hash-ref symboltable info #f))) 
                    (hash-set! symboltable info PC)]
         [(and (eq? type 'LABEL) (hash-ref symboltable info #f)) (exit (eprintf "ERROR"))])
  )
  (cond[(increasepc? line) (set! PC (increment PC))])
)

(set! PC 0)

(for ([i proglen])
  (define line (list-ref program i))
  (define linelen (length line))
  (define cleanline (clean line))
  (define instrlen (length cleanline))
  (cond[(not (checkregisters line)) (exit (eprintf "ERROR"))])
  (cond[(and (>= (length cleanline) 1) (not (valid? cleanline))) (exit (eprintf "ERROR"))])
  (cond[(not (eq? 0 instrlen)) (dealer cleanline PC)])
  (cond[(increasepc? line) (set! PC (increment PC))])
)